<center><a href="ex91.c">Actual source code: ex91.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:26:31+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests <A href="../../../../docs/manualpages/Mat/MatIncreaseOverlap.html#MatIncreaseOverlap">MatIncreaseOverlap</A>(), <A href="../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>() for sequential MatSBAIJ format. Derived from ex51.c\n"</font>;

<a name="line4"> 4: </a> #include <A href="../../../../include/petscmat.h.html">petscmat.h</A>

<a name="line8">  8: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **args)</font></strong>
<a name="line9">  9: </a>{
<a name="line10"> 10: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            A,Atrans,sA,*submatA,*submatsA;
<a name="line11"> 11: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       bs=1,m=43,ov=1,i,j,k,*rows,*cols,M,nd=5,*idx,mm,nn;
<a name="line13"> 13: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line14"> 14: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *vals,rval,one=1.0;
<a name="line15"> 15: </a>  <A href="../../../../docs/manualpages/IS/IS.html#IS">IS</A>             *is1,*is2;
<a name="line16"> 16: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandom.html#PetscRandom">PetscRandom</A>    rand;
<a name="line17"> 17: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            xx,s1,s2;
<a name="line18"> 18: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      s1norm,s2norm,rnorm,tol = 1.e-10;
<a name="line19"> 19: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;

<a name="line21"> 21: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;args,(char *)0,help);
<a name="line22"> 22: </a>

<a name="line24"> 24: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-mat_block_size"</font>,&amp;bs,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line25"> 25: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-mat_size"</font>,&amp;m,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line26"> 26: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-ov"</font>,&amp;ov,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line27"> 27: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-nd"</font>,&amp;nd,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line29"> 29: </a>  <font color="#B22222">/* create a SeqBAIJ matrix A */</font>
<a name="line30"> 30: </a>  M    = m*bs;
<a name="line31"> 31: </a>  <A href="../../../../docs/manualpages/Mat/MatCreateSeqBAIJ.html#MatCreateSeqBAIJ">MatCreateSeqBAIJ</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,bs,M,M,1,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;A);
<a name="line32"> 32: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomCreate.html#PetscRandomCreate">PetscRandomCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,&amp;rand);
<a name="line33"> 33: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomSetFromOptions.html#PetscRandomSetFromOptions">PetscRandomSetFromOptions</A>(rand);

<a name="line35"> 35: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(bs*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;rows);
<a name="line36"> 36: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(bs*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;cols);
<a name="line37"> 37: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(bs*bs*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;vals);
<a name="line38"> 38: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(M*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;idx);
<a name="line39"> 39: </a>
<a name="line40"> 40: </a>  <font color="#B22222">/* Now set blocks of random values */</font>
<a name="line41"> 41: </a>  <font color="#B22222">/* first, set diagonal blocks as zero */</font>
<a name="line42"> 42: </a>  <font color="#4169E1">for</font> (j=0; j&lt;bs*bs; j++) vals[j] = 0.0;
<a name="line43"> 43: </a>  <font color="#4169E1">for</font> (i=0; i&lt;m; i++){
<a name="line44"> 44: </a>    cols[0] = i*bs; rows[0] = i*bs;
<a name="line45"> 45: </a>    <font color="#4169E1">for</font> (j=1; j&lt;bs; j++) {
<a name="line46"> 46: </a>      rows[j] = rows[j-1]+1;
<a name="line47"> 47: </a>      cols[j] = cols[j-1]+1;
<a name="line48"> 48: </a>    }
<a name="line49"> 49: </a>    <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,bs,rows,bs,cols,vals,<A href="../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>);
<a name="line50"> 50: </a>  }
<a name="line51"> 51: </a>  <font color="#B22222">/* second, add random blocks */</font>
<a name="line52"> 52: </a>  <font color="#4169E1">for</font> (i=0; i&lt;20*bs; i++) {
<a name="line53"> 53: </a>      <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rand,&amp;rval);
<a name="line54"> 54: </a>      cols[0] = bs*(int)(PetscRealPart(rval)*m);
<a name="line55"> 55: </a>      <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rand,&amp;rval);
<a name="line56"> 56: </a>      rows[0] = bs*(int)(PetscRealPart(rval)*m);
<a name="line57"> 57: </a>      <font color="#4169E1">for</font> (j=1; j&lt;bs; j++) {
<a name="line58"> 58: </a>        rows[j] = rows[j-1]+1;
<a name="line59"> 59: </a>        cols[j] = cols[j-1]+1;
<a name="line60"> 60: </a>      }

<a name="line62"> 62: </a>      <font color="#4169E1">for</font> (j=0; j&lt;bs*bs; j++) {
<a name="line63"> 63: </a>        <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rand,&amp;rval);
<a name="line64"> 64: </a>        vals[j] = rval;
<a name="line65"> 65: </a>      }
<a name="line66"> 66: </a>      <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,bs,rows,bs,cols,vals,<A href="../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>);
<a name="line67"> 67: </a>  }

<a name="line69"> 69: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(A,MAT_FINAL_ASSEMBLY);
<a name="line70"> 70: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(A,MAT_FINAL_ASSEMBLY);

<a name="line72"> 72: </a>  <font color="#B22222">/* make A a symmetric matrix: A &lt;- A^T + A */</font>
<a name="line73"> 73: </a>  <A href="../../../../docs/manualpages/Mat/MatTranspose.html#MatTranspose">MatTranspose</A>(A, &amp;Atrans);
<a name="line74"> 74: </a>  <A href="../../../../docs/manualpages/Mat/MatAXPY.html#MatAXPY">MatAXPY</A>(A,one,Atrans,DIFFERENT_NONZERO_PATTERN);
<a name="line75"> 75: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(Atrans);
<a name="line76"> 76: </a>  <A href="../../../../docs/manualpages/Mat/MatTranspose.html#MatTranspose">MatTranspose</A>(A, &amp;Atrans);
<a name="line77"> 77: </a>  <A href="../../../../docs/manualpages/Mat/MatEqual.html#MatEqual">MatEqual</A>(A, Atrans, &amp;flg);
<a name="line78"> 78: </a>  <font color="#4169E1">if</font> (!flg) {
<a name="line79"> 79: </a>    <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"A+A^T is non-symmetric"</font>);
<a name="line80"> 80: </a>  }
<a name="line81"> 81: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(Atrans);

<a name="line83"> 83: </a>  <font color="#B22222">/* create a SeqSBAIJ matrix sA (= A) */</font>
<a name="line84"> 84: </a>  <A href="../../../../docs/manualpages/Mat/MatConvert.html#MatConvert">MatConvert</A>(A,<A href="../../../../docs/manualpages/Mat/MATSEQSBAIJ.html#MATSEQSBAIJ">MATSEQSBAIJ</A>,MAT_INITIAL_MATRIX,&amp;sA);
<a name="line85"> 85: </a>
<a name="line86"> 86: </a>  <font color="#B22222">/* Test sA==A through <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>() */</font>
<a name="line87"> 87: </a>  <font color="#4169E1">for</font> (i=0; i&lt;nd; i++) {
<a name="line88"> 88: </a>    <A href="../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(A,&amp;mm,&amp;nn);
<a name="line89"> 89: </a>    <A href="../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,mm,&amp;xx);
<a name="line90"> 90: </a>    <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(xx,&amp;s1);
<a name="line91"> 91: </a>    <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(xx,&amp;s2);
<a name="line92"> 92: </a>    <font color="#4169E1">for</font> (j=0; j&lt;3; j++) {
<a name="line93"> 93: </a>      <A href="../../../../docs/manualpages/Vec/VecSetRandom.html#VecSetRandom">VecSetRandom</A>(xx,rand);
<a name="line94"> 94: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(A,xx,s1);
<a name="line95"> 95: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(sA,xx,s2);
<a name="line96"> 96: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(s1,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;s1norm);
<a name="line97"> 97: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(s2,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;s2norm);
<a name="line98"> 98: </a>      rnorm = s2norm-s1norm;
<a name="line99"> 99: </a>      <font color="#4169E1">if</font> (rnorm&lt;-tol || rnorm&gt;tol) {
<a name="line100">100: </a>        <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Error:<A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A> - Norm1=%16.14e Norm2=%16.14e\n"</font>,s1norm,s2norm);
<a name="line101">101: </a>      }
<a name="line102">102: </a>    }
<a name="line103">103: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(xx);
<a name="line104">104: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(s1);
<a name="line105">105: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(s2);
<a name="line106">106: </a>  }

<a name="line108">108: </a>  <font color="#B22222">/* Test <A href="../../../../docs/manualpages/Mat/MatIncreaseOverlap.html#MatIncreaseOverlap">MatIncreaseOverlap</A>() */</font>
<a name="line109">109: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nd*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/IS/IS.html#IS">IS</A> **),&amp;is1);
<a name="line110">110: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nd*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/IS/IS.html#IS">IS</A> **),&amp;is2);

<a name="line112">112: </a>
<a name="line113">113: </a>  <font color="#4169E1">for</font> (i=0; i&lt;nd; i++) {
<a name="line114">114: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rand,&amp;rval);
<a name="line115">115: </a>    <A href="../../../../docs/manualpages/Sys/size.html#size">size</A> = (int)(PetscRealPart(rval)*m);
<a name="line116">116: </a>    <font color="#4169E1">for</font> (j=0; j&lt;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>; j++) {
<a name="line117">117: </a>      <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rand,&amp;rval);
<a name="line118">118: </a>      idx[j*bs] = bs*(int)(PetscRealPart(rval)*m);
<a name="line119">119: </a>      <font color="#4169E1">for</font> (k=1; k&lt;bs; k++) idx[j*bs+k] = idx[j*bs]+k;
<a name="line120">120: </a>    }
<a name="line121">121: </a>    <A href="../../../../docs/manualpages/IS/ISCreateGeneral.html#ISCreateGeneral">ISCreateGeneral</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>*bs,idx,is1+i);
<a name="line122">122: </a>    <A href="../../../../docs/manualpages/IS/ISCreateGeneral.html#ISCreateGeneral">ISCreateGeneral</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>*bs,idx,is2+i);
<a name="line123">123: </a>  }
<a name="line124">124: </a>  <font color="#B22222">/* for debugging */</font>
<a name="line125">125: </a>  <font color="#B22222">/*</font>
<a name="line126">126: </a><font color="#B22222">  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(A,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>); </font>
<a name="line127">127: </a><font color="#B22222">  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(sA,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>); </font>
<a name="line128">128: </a><font color="#B22222">  */</font>

<a name="line130">130: </a>  <A href="../../../../docs/manualpages/Mat/MatIncreaseOverlap.html#MatIncreaseOverlap">MatIncreaseOverlap</A>(A,nd,is1,ov);
<a name="line131">131: </a>  <A href="../../../../docs/manualpages/Mat/MatIncreaseOverlap.html#MatIncreaseOverlap">MatIncreaseOverlap</A>(sA,nd,is2,ov);

<a name="line133">133: </a>  <font color="#4169E1">for</font> (i=0; i&lt;nd; ++i) {
<a name="line134">134: </a>    <A href="../../../../docs/manualpages/IS/ISSort.html#ISSort">ISSort</A>(is1[i]);
<a name="line135">135: </a>    <A href="../../../../docs/manualpages/IS/ISSort.html#ISSort">ISSort</A>(is2[i]);
<a name="line136">136: </a>  }

<a name="line138">138: </a>  <font color="#4169E1">for</font> (i=0; i&lt;nd; ++i) {
<a name="line139">139: </a>    <A href="../../../../docs/manualpages/IS/ISEqual.html#ISEqual">ISEqual</A>(is1[i],is2[i],&amp;flg);
<a name="line140">140: </a>    <font color="#4169E1">if</font> (!flg){
<a name="line141">141: </a>      <font color="#B22222">/* <A href="../../../../docs/manualpages/IS/ISView.html#ISView">ISView</A>(is1[i],<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);</font>
<a name="line142">142: </a><font color="#B22222">         <A href="../../../../docs/manualpages/IS/ISView.html#ISView">ISView</A>(is2[i],<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>); */</font>
<a name="line143">143: </a>      <A href="../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(1,<font color="#666666">"i=%d, is1 != is2"</font>,i);
<a name="line144">144: </a>    }
<a name="line145">145: </a>  }
<a name="line146">146: </a>
<a name="line147">147: </a>  <A href="../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>(A,nd,is1,is1,MAT_INITIAL_MATRIX,&amp;submatA);
<a name="line148">148: </a>  <A href="../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>(sA,nd,is2,is2,MAT_INITIAL_MATRIX,&amp;submatsA);

<a name="line150">150: </a>  <font color="#B22222">/* Test <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>() */</font>
<a name="line151">151: </a>  <font color="#4169E1">for</font> (i=0; i&lt;nd; i++) {
<a name="line152">152: </a>    <A href="../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(submatA[i],&amp;mm,&amp;nn);
<a name="line153">153: </a>    <A href="../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,mm,&amp;xx);
<a name="line154">154: </a>    <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(xx,&amp;s1);
<a name="line155">155: </a>    <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(xx,&amp;s2);
<a name="line156">156: </a>    <font color="#4169E1">for</font> (j=0; j&lt;3; j++) {
<a name="line157">157: </a>      <A href="../../../../docs/manualpages/Vec/VecSetRandom.html#VecSetRandom">VecSetRandom</A>(xx,rand);
<a name="line158">158: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(submatA[i],xx,s1);
<a name="line159">159: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(submatsA[i],xx,s2);
<a name="line160">160: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(s1,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;s1norm);
<a name="line161">161: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(s2,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;s2norm);
<a name="line162">162: </a>      rnorm = s2norm-s1norm;
<a name="line163">163: </a>      <font color="#4169E1">if</font> (rnorm&lt;-tol || rnorm&gt;tol) {
<a name="line164">164: </a>        <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Error:<A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A> - Norm1=%16.14e Norm2=%16.14e\n"</font>,s1norm,s2norm);
<a name="line165">165: </a>      }
<a name="line166">166: </a>    }
<a name="line167">167: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(xx);
<a name="line168">168: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(s1);
<a name="line169">169: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(s2);
<a name="line170">170: </a>  }

<a name="line172">172: </a>  <font color="#B22222">/* Now test MatGetSubmatrices with MAT_REUSE_MATRIX option */</font>
<a name="line173">173: </a>  <A href="../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>(A,nd,is1,is1,MAT_REUSE_MATRIX,&amp;submatA);
<a name="line174">174: </a>  <A href="../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>(sA,nd,is2,is2,MAT_REUSE_MATRIX,&amp;submatsA);
<a name="line175">175: </a>
<a name="line176">176: </a>  <font color="#B22222">/* Test <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>() */</font>
<a name="line177">177: </a>  <font color="#4169E1">for</font> (i=0; i&lt;nd; i++) {
<a name="line178">178: </a>    <A href="../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(submatA[i],&amp;mm,&amp;nn);
<a name="line179">179: </a>    <A href="../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,mm,&amp;xx);
<a name="line180">180: </a>    <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(xx,&amp;s1);
<a name="line181">181: </a>    <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(xx,&amp;s2);
<a name="line182">182: </a>    <font color="#4169E1">for</font> (j=0; j&lt;3; j++) {
<a name="line183">183: </a>      <A href="../../../../docs/manualpages/Vec/VecSetRandom.html#VecSetRandom">VecSetRandom</A>(xx,rand);
<a name="line184">184: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(submatA[i],xx,s1);
<a name="line185">185: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(submatsA[i],xx,s2);
<a name="line186">186: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(s1,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;s1norm);
<a name="line187">187: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(s2,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;s2norm);
<a name="line188">188: </a>      rnorm = s2norm-s1norm;
<a name="line189">189: </a>      <font color="#4169E1">if</font> (rnorm&lt;-tol || rnorm&gt;tol) {
<a name="line190">190: </a>        <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Error:<A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A> - Norm1=%16.14e Norm2=%16.14e\n"</font>,s1norm,s2norm);
<a name="line191">191: </a>      }
<a name="line192">192: </a>    }
<a name="line193">193: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(xx);
<a name="line194">194: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(s1);
<a name="line195">195: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(s2);
<a name="line196">196: </a>  }
<a name="line197">197: </a>
<a name="line198">198: </a>  <font color="#B22222">/* Free allocated memory */</font>
<a name="line199">199: </a>  <font color="#4169E1">for</font> (i=0; i&lt;nd; ++i) {
<a name="line200">200: </a>    <A href="../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(is1[i]);
<a name="line201">201: </a>    <A href="../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(is2[i]);
<a name="line202">202: </a>
<a name="line203">203: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(submatA[i]);
<a name="line204">204: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(submatsA[i]);
<a name="line205">205: </a>
<a name="line206">206: </a>  }
<a name="line207">207: </a>
<a name="line208">208: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(submatA);
<a name="line209">209: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(submatsA);
<a name="line210">210: </a>
<a name="line211">211: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(is1);
<a name="line212">212: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(is2);
<a name="line213">213: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(idx);
<a name="line214">214: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(rows);
<a name="line215">215: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(cols);
<a name="line216">216: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(vals);
<a name="line217">217: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A);
<a name="line218">218: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(sA);
<a name="line219">219: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomDestroy.html#PetscRandomDestroy">PetscRandomDestroy</A>(rand);
<a name="line220">220: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line221">221: </a>  <font color="#4169E1">return</font> 0;
<a name="line222">222: </a>}
</pre>
</body>

</html>
